DO
$body$
DECLARE 
num_errors int;
loop_num int = 1;
start_time timestamp WITH time zone;
done_time timestamp WITH time zone;

BEGIN

LOOP
start_time := Clock_timestamp();

CALL resolve_overlap_gap_run(
('test_data.overlap_gap_input_t3','id','geom',25833,true), -- TYPE resolve_overlap_data_input
('test_topo_t3_ok',1.0), -- TYPE resolve_overlap_data_topology
resolve_overlap_data_clean_type_func(  -- TYPE resolve_overlap_data_clean
49,  -- if this a polygon  is below this limit it will merge into a neighbour polygon. The area is sqare meter.
10, -- is this is more than zero simply will called with
null, -- _max_average_vertex_length, in meter both for utm and deegrees, this used to avoid running ST_simplifyPreserveTopology for long lines lines with few points
2, -- IF 0 NO CHAKINS WILL BE DONE A big value here make no sense because the number of points will increaes exponential )
10000, --edge that are longer than this value will not be touched by _chaikins_min_degrees and _chaikins_max_degrees  
120, -- The angle has to be less this given value, This is used to avoid to touch all angles. 
240, -- OR the angle has to be greather than this given value, This is used to avoid to touch all angles 
40, -- The angle has to be less this given value, This is used to avoid to touch all angles. 
320 -- OR The angle has to be greather than this given value, This is used to avoid to touch all angles 
),
4, -- number of threads 
15, -- max numver of polygons in each cell 
resolve_overlap_data_debug_options_func(
  true, --if set to false, it will do topology.ValidateTopology and stop to if the this call returns any rows
  true, -- if set to true, it will do topology.ValidateTopology at each loop return if it's error 
  false, --  if set to false, it will in many cases generate topo errors beacuse of running in many parralell threads
  1, -- if set to more than 1 it will skip init procces and start at given job_type
  1, -- many of jobs are ran in loops beacuse because if get an exception or cell is not allowed handle because cell close to is also started to work , this cell will gandled in the next loop.
  3, -- if set to more than 0 the job will stop  when this job type is reday to run and display a set sql to run
  1 -- if set to more than 0 the job will stop  when this job type is reday to run and display a set sql to run
  ) 
);

done_time := Clock_timestamp();

SELECT count(*) FROM topology.ValidateTopology('test_topo_t3_ok') into num_errors;

loop_num := loop_num + 1;
RAISE NOTICE 'Done with loop % with % Topology errors on test_topo_t3_ok in % seconds at % .', 
loop_num, num_errors, (Extract(EPOCH FROM (done_time - start_time))), now() ;

EXIT WHEN num_errors > 0 or loop_num > 20;

END LOOP;

END
$body$;


SELECT 'validation', * FROM topology.ValidateTopology('test_topo_t3_ok');


 

